library HookDll2;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Forms,
  ApiHook in 'ApiHook.pas',
  MainForm in 'MainForm.pas' {frmMain};

var
  DllData: PDATA;

{$R *.res}

{-------------------------------------------------------------------------------
  e{W:    WinHookProc
  @:      Administrator
  :      2004.03.18
  :      nCode, wParam, lParam: DWORD
  ^:    DWORD
-------------------------------------------------------------------------------}
function WinHookProc(nCode, wParam, lParam: DWORD): DWORD; stdcall;
begin
  if not DllData^.Hooked then begin
    HookAPI;
    DllData^.Hooked := True;
    frmMain := TfrmMain.Create(nil);
    frmMain.FDllData := DllData;
    frmMain.Show;
  end;
  Result := CallNextHookEx(DllData^.HookData, nCode, wParam, lParam);
end;

{-------------------------------------------------------------------------------
  e{W:    HookProc
  @:      Administrator
  :      2004.03.16
  :      nCode, wParam, lParam: DWORD
  ^:    L
-------------------------------------------------------------------------------}

function HookProc(nCode, wParam, lParam: DWORD): DWORD; stdcall;
var
  hWin: THandle;
  ThreadId: THandle;
begin
  if nCode = HC_ACTION then begin
    if (wParam = VK_HOME) and ((lParam and (1 shl 31)) <> 0) and (DllData^.HookData = 0) then begin
      hWin := GetForegroundWindow;
      ThreadId := GetWindowThreadProcessId(hWIn);
      DllData^.HookData := SetWindowsHookEx(WH_GETMESSAGE, @WinHookProc, hInstance, ThreadId);
      DllData^.Hooked := False;
    end;
  end;
  Result := CallNextHookEx(DllData^.Hook, nCode, wParam, lParam);
end;

{-------------------------------------------------------------------------------
  e{W:    StartHook
  @:      Administrator
  :      2004.03.16
  :      hWin: HWND
  ^:    Boolean
-------------------------------------------------------------------------------}

function StartHook: Boolean; stdcall;
begin
  Result := False;
  DllData^.HookData := 0;
  DllData^.Hook := SetWindowsHookEx(WH_KEYBOARD, @HookProc, hInstance, 0);
  if DllData^.Hook > 0 then
    Result := True;
end;

{-------------------------------------------------------------------------------
  e{W:    StopHook
  @:      Administrator
  :      2004.03.16
  :      L
  ^:    L
-------------------------------------------------------------------------------}

procedure StopHook; stdcall;
begin
//  UnHookAPI;
  UnhookWindowsHookEx(DllData^.Hook);
  if DllData^.HookData <> 0 then begin
    UnHookApi;
    UnhookWindowsHookEx(DllData^.HookData);
  end;
end;

{-------------------------------------------------------------------------------
  e{W:    HookHandler
  @:      Administrator
  :      2004.03.16
  :      Reason: Integer
  ^:    L
-------------------------------------------------------------------------------}

procedure HookHandler(Reason: Integer);
var
  fHandle: THandle;
begin
  case (Reason) of
    DLL_PROCESS_ATTACH:
      begin
        fHandle := CreateFileMapping(INVALID_HANDLE_VALUE, nil, PAGE_READWRITE, 0, $FFFF, 'HooKData2');
        if fHandle = 0 then
          if GetLastError = ERROR_ALREADY_EXISTS then begin
            fHandle := OpenFileMapping(FILE_MAP_ALL_ACCESS, False, 'HookData2');
            if fHandle = 0 then
              Exit;
          end
          else
            Exit;
        DllData := MapViewOfFile(fHandle, FILE_MAP_ALL_ACCESS, 0, 0, 0);
        if DllData = nil then
          CloseHandle(fHandle);
      end;
    DLL_PROCESS_DETACH:
      begin
        if Assigned(DllData) then begin
          UnmapViewOfFile(DllData);
          DllData := nil;
        end;
      end;
  end;
end;

exports
  StartHook, StopHook;

begin
  DllProc := @HookHandler;
  HookHandler(DLL_PROCESS_ATTACH);
  DllData^.Hooked := False;
end.

